#include "double.h"
#include "aspen_devel.h"


extern "C" void
API(dgemv) ( char trans, int m, int n,
                      scalar_t alpha, 
                      scalar_t * a, int lda,
                      scalar_t * x, int incx,
                      scalar_t beta,  
                      scalar_t * y, int incy )
{
   if ( n <= 0 ) return;
   if ( alpha == (scalar_t)0 && beta == (scalar_t)1 ) return;
   if ( (trans!='N')&&(trans!='n')&&(trans!='T')&&(trans!='t')&&
        (trans!='C')&&(trans!='c')) return;

        if ( incx == 1 && incy == 1 ) {
            int     Trans = (trans=='N')||(trans=='n');
            if ( Trans ) {
                API(DGEMV_n) ( -1, alpha, beta, a, x, y, lda, m, n );
            } else {
                API(DGEMV_t) ( -1, alpha, beta, a, x, y, lda, n, m );
            }
        } else {
                cublasDgemv ( trans, m, n, alpha, a, lda, x, incx, beta, y, incy );
        }

        return;
}

