#include "double.h"
#include "aspen_devel.h"


extern "C"void
API(DSYMVu) ( const int blk,
	const int n, const scalar_t * A, const int lda,
	const scalar_t * x, scalar_t * y,
	const scalar_t alpha, const scalar_t beta )
{
	API(DSYMVu_LARGE) ( blk, n, A, lda, x, y, alpha, beta );
}

extern "C" void
API(dsymv) ( char uplo, int n,
                      scalar_t alpha, 
                      scalar_t * a, int lda,
                      scalar_t * x, int incx,
                      scalar_t beta,  
                      scalar_t * y, int incy )
{
   if ( n <= 0 ) return;
   if ( alpha == (scalar_t)0 && beta == (scalar_t)1 ) return;
	int	upper = (uplo=='U')||(uplo=='u');
	if ( upper && incx == 1 && incy == 1 ) {
		API(DSYMVu_LARGE) ( -1, n, a, lda, x, y, alpha, beta );
	} else {
		cublasDsymv ( uplo, n, alpha, a, lda, x, incx, beta, y, incy );
	}
}

