#include "double.h"
#include "aspen_devel.h"

#define	GPU_ARCH	Tesla

//#if USE_TEXTURE
DEF_TEXTURE ( texture_X, X );
//#endif

#define	SUMUP_PREFIX	DSYMV_U_TESLA
#include "../template/sumup_1Dx2_template.incl"



#define	NUM_THREADS	256
#define	USE_TEXTURE	1
#define	SPLIT_LOOP	1
#define	UNROLL		1
#define	UMAX_DEFAULT	2
#define LOOP_RANGE_ARRAY	0


//#include "../template/symv_upper_blocked_template.incl"
#include "../template/symv_upper_ticket_template.incl"
//#include "../template/symv_upper_atomic_template.incl"


extern "C" void
API(DSYMVu_LARGE_TESLA) ( const int blk,
         const int n, const scalar_t * a, const int lda,
         const scalar_t *x , scalar_t * y,
         const scalar_t alpha, const scalar_t beta )
{

// y = alpha * A * x + beta * y
// y(1:n1)
// x(1:n2)

   if ( n <= 0 ) return;
   if ( alpha == (scalar_t)0 && beta == (scalar_t)1 ) return;

      API(SYMVu_TICKET_host) < scalar_t, 64, 12, 4 >
         ( n, a, lda, x, y, alpha, beta );

}

