#include "float.h"
#include "aspen_devel.h"


extern "C" void
API(SGEMV_n) ( int blk,
		const scalar_t alpha, const scalar_t beta,
		const scalar_t * a, const scalar_t * x,
		scalar_t * y,
                const int lda,
		const int n1, const int n2 )
{

   if ( n1 <= 0 || n2 <= 0 ) return;
   if ( alpha == (scalar_t)0 && beta == (scalar_t)1 ) return;

   int Ver = API(get_device_Major) ( );

   switch ( Ver ) {
   case Tesla:
	API(SGEMV_n_TESLA) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
   case Fermi:
	API(SGEMV_n_FERMI) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
   case Kepler:
	API(SGEMV_n_KEPLER) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
   case Maxwell:
	API(SGEMV_n_MAXWELL) ( blk,
		alpha, beta, a, x, y, lda, n1, n2 );
	break;
   }

}

