#include "float.h"
#include "aspen_devel.h"


#define	GPU_ARCH	Tesla

#define	SUMUP_PREFIX	SSYMV_U_TESLA
#include "../template/sumup_1Dx2_template.incl"


#define	NUM_THREADS	256
#define	USE_TEXTURE	1
#define	SPLIT_LOOP	1
#define	UNROLL		1
#define UMAX_DEFAULT	3
#define	LOOP_RANGE_ARRAY	1

#if USE_TEXTURE
DEF_TEXTURE( texture_X, X );
#endif

#include "../template/symv_upper_blocked_template.incl"
#include "../template/symv_upper_ticket_template.incl"
#include "../template/symv_upper_atomic_template.incl"


extern "C" void
API(SSYMVu_LARGE_TESLA) ( const int blk,
         const int n, const scalar_t * a, const int lda,
         const scalar_t * x, scalar_t * y,
         const scalar_t alpha, const scalar_t beta )
{

// y = alpha * A * x + beta * y
// y(1:n1)
// x(1:n2)

      int BLK = blk;
      if ( BLK <= 0 ) {
          BLK = 20;
      }

      switch ( BLK ) {
      case 19:
      API(SYMVu_TICKET_host) < scalar_t, 128, 19, 5 >
         ( n, a, lda, x, y, alpha, beta );
      break;
      default:
      case 20:
      API(SYMVu_TICKET_host) < scalar_t, 128, 20, 5 >
         ( n, a, lda, x, y, alpha, beta );
      break;
      case 21:
      API(SYMVu_TICKET_host) < scalar_t, 128, 21, 5 >
         ( n, a, lda, x, y, alpha, beta );
      break;
      case 115:
      API(SYMVu_BLOCKED_host) < scalar_t, 128, 15, 5 >
         ( n, a, lda, x, y, alpha, beta );
      break;
      }

}

