#include "float.h"
#include "aspen_devel.h"


#define	USE_TEXTURE	0
#if USE_TEXTURE
DEF_TEXTURE( texture_X, X_ );
#endif

#define SUMUP_PREFIX    STRMV_N_UPPER_FOR_SYMV
#include "../template/sumup_2D_template.incl"
#include "../template/trmv_n_upper_for_symv_template.incl"


#define	BLOCK_X_V1	32
#define	BLOCK_Y_V1	6
#define	BLOCK_X_V2	32
#define	BLOCK_Y_V2	5
#define	BLOCK_X_V3	32
#define	BLOCK_Y_V3	12
#define	BLOCK_X_V5	32
#define	BLOCK_Y_V5	12


extern "C" void
API(STRMV_n_upper_for_SSYMV) (
		const scalar_t alpha, const scalar_t beta,
		const scalar_t * a, const scalar_t * x,
		scalar_t * y,
                const int lda,
		const int n)
{
   int  Ver = API(get_device_Major) ( );
   switch ( Ver ) {
   case Tesla:
      API(TRMV_n_upper_for_SYMV_host) < scalar_t, BLOCK_X_V1, BLOCK_Y_V1 >
         ( alpha, beta, a, x, y,lda, n );
      break;
   case Fermi:
      API(TRMV_n_upper_for_SYMV_host) < scalar_t, BLOCK_X_V2, BLOCK_Y_V2 >
         ( alpha, beta, a, x, y,lda, n );
      break;
   case Kepler:
      API(TRMV_n_upper_for_SYMV_host) < scalar_t, BLOCK_X_V3, BLOCK_Y_V3 >
         ( alpha, beta, a, x, y,lda, n );
      break;
   case Maxwell:
      API(TRMV_n_upper_for_SYMV_host) < scalar_t, BLOCK_X_V5, BLOCK_Y_V5 >
         ( alpha, beta, a, x, y,lda, n );
      break;
   }
}


