#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
Thu Jul 31 21:45:33 JST 2014
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

if ( n >= 1 && n < 206 ) {
	BLK = 6;
} else 
if ( n >= 206 && n < 309 ) {
	BLK = 5;
} else 
if ( n >= 309 && n < 720 ) {
	BLK = 12;
} else 
if ( n >= 720 && n < 840 ) {
	BLK = 16;
} else 
if ( n >= 840 && n < 878 ) {
	BLK = 8;
} else 
if ( n >= 878 && n < 900 ) {
	BLK = 14;
} else 
if ( n >= 900 && n < 956 ) {
	BLK = 8;
} else 
if ( n >= 956 && n < 1350 ) {
	BLK = 17;
} else 
if ( n >= 1350 && n < 1620 ) {
	BLK = 5;
} else 
if ( n >= 1620 && n < 1920 ) {
	BLK = 6;
} else 
if ( n >= 1920 && n < 2115 ) {
	BLK = 2;
} else 
if ( n >= 2115 && n < 2400 ) {
	BLK = 11;
} else 
if ( n >= 2400 && n < 2880 ) {
	BLK = 15;
} else 
if ( n >= 2880 && n < 3000 ) {
	BLK = 8;
} else 
if ( n >= 3000 && n < 3026 ) {
	BLK = 18;
} else 
if ( n >= 3026 && n < 3197 ) {
	BLK = 8;
} else 
if ( n >= 3197 && n < 3240 ) {
	BLK = 5;
} else 
if ( n >= 3240 && n < 3300 ) {
	BLK = 8;
} else 
if ( n >= 3300 && n < 3341 ) {
	BLK = 18;
} else 
if ( n >= 3341 && n < 3347 ) {
	BLK = 8;
} else 
if ( n >= 3347 && n < 3360 ) {
	BLK = 19;
} else 
if ( n >= 3360 && n < 3458 ) {
	BLK = 8;
} else 
if ( n >= 3458 && n < 3585 ) {
	BLK = 7;
} else 
if ( n >= 3585 && n < 3600 ) {
	BLK = 19;
} else 
if ( n >= 3600 && n < 3637 ) {
	BLK = 18;
} else 
if ( n >= 3637 && n < 3680 ) {
	BLK = 7;
} else 
if ( n >= 3680 && n < 3840 ) {
	BLK = 6;
} else 
if ( n >= 3840 && n < 3900 ) {
	BLK = 7;
} else 
if ( n >= 3900 && n < 3903 ) {
	BLK = 18;
} else 
if ( n >= 3903 && n < 4005 ) {
	BLK = 7;
} else 
if ( n >= 4005 && n < 4050 ) {
	BLK = 17;
} else 
if ( n >= 4050 && n < 4891 ) {
	BLK = 7;
} else 
	BLK = 4;

#define	_KERNEL_4 1
#define	_KERNEL_17 1
#define	_KERNEL_18 1
#define	_KERNEL_5 1
#define	_KERNEL_19 1
#define	_KERNEL_6 1
#define	_KERNEL_7 1
#define	_KERNEL_8 1
#define	_KERNEL_11 1
#define	_KERNEL_12 1
#define	_KERNEL_14 1
#define	_KERNEL_15 1
#define	_KERNEL_2 1
#define	_KERNEL_16 1

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if _KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 288 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 32 , 3 , 3, 1 );
		break;
#endif
#if _KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 64 , 2 , 6, 1 );
		break;
#endif
#if _KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 32 , 2 , 4, 1 );
		break;
#endif
#if _KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 256 , 1 , 3, 1 );
		break;
#endif
#if _KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 32 , 4 , 4, 1 );
		break;
#endif
#if _KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 32 , 2 , 5, 1 );
		break;
#endif
#if _KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 64 , 2 , 2, 1 );
		break;
#endif
#if _KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 32 , 4 , 3, 1 );
		break;
#endif
#if _KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
#endif
#if _KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 32 , 2 , 6, 1 );
		break;
#endif
#if _KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 128 , 2 , 2, 1 );
		break;
#endif
#if _KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 64 , 2 , 5, 1 );
		break;
#endif
#if _KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if _KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

